<ion-header [translucent]="true">
  <ion-toolbar>
    <ion-title>
      <ion-grid>
        <ion-row>
          <ion-col size="3">
            <ion-icon
              class="ion-text-start"
              (click)="openMenu()"
              name="menu-outline"
            ></ion-icon>
          </ion-col>
          <ion-col *ngIf="currentFolder" size="1">
            <ion-icon [name]="currentFolder.icon" style="font-size: 20px;"> </ion-icon>
          </ion-col>
          <ion-col size="7">
            <ion-title
              >{{ currentFolder && currentFolder.name ? currentFolder.name : 'Welcome' }}</ion-title>
          </ion-col>
          <ion-col *ngIf="currentFolder" size="1">
            <ng-template
            [ngIf]="!deleteMode"
            [ngIfElse]="deleteId">
              <ion-icon
                class="ion-text-end"
                style="font-size: 20px;"
                (click)="setDeleteModeOn()"
                name="trash-outline"
              ></ion-icon>
            </ng-template>
            <ng-template #deleteId>
              <ion-icon
                class="ion-text-end"
                style="font-size: 20px;"
                (click)="validateDelete()"
                name="checkmark-outline"
              ></ion-icon>
            </ng-template>
          </ion-col>
        </ion-row>
        <ion-row *ngIf="currentFolder && currentFolder.color" class="color-line" [ngStyle]="{'background-color': currentFolder.color}">

        </ion-row>
      </ion-grid>
    </ion-title>
  </ion-toolbar>
</ion-header>

<ion-content>
  <ion-backdrop *ngIf="!loaded"></ion-backdrop>
  <ng-template [ngIf]="currentFolder" [ngIfElse]="noFolderToDisplay">
    <ion-list class="grey-background">
      <div *ngFor="let folder of currentFolder.folders">
        <ion-card>
          <ion-grid>
            <ion-row>
              <ion-col size="1">
                <div class="height-line-folder" [ngStyle]="{'background-color': folder.color}"></div>
              </ion-col>
              <ion-col size="2">
                <ion-icon
                  class="ion-margin-horizontal bigger-icon"
                  [name]="folder.icon"
                ></ion-icon>
              </ion-col>
              <ion-col size="7">
                {{ truncateString(folder.name, 14) }}
              </ion-col>
              <ion-col size="1">
                <ng-template
                  [ngIf]="folder.isDeployed"
                  [ngIfElse]="displayedNested1"
                >
                  <ion-icon
                    class="ion-text-end"
                    (click)="deployFolder(folder)"
                    name="caret-down-outline"
                  ></ion-icon>
                </ng-template>
                <ng-template #displayedNested1>
                  <ion-icon
                    class="ion-text-end"
                    (click)="deployFolder(folder)"
                    name="caret-forward-outline"
                  ></ion-icon>
                </ng-template>
              </ion-col>
              <ion-col size="1">
                <ng-template
                  [ngIf]="deleteMode && !folder.onDelete"
                  [ngIfElse]="deleteMode && onDeleteFolderTrue1">
                  <ion-icon (click)="addFolderToDeleteList(folder)" name="square-outline"></ion-icon>
                </ng-template>
                <ng-template #onDeleteFolderTrue1>
                  <ion-icon (click)="removeFolderFromDeleteList(folder)" name="checkbox-outline"></ion-icon>    
                </ng-template>
              </ion-col>
            </ion-row>
          </ion-grid>
        </ion-card>
        <div *ngIf="folder.isDeployed">
          <!-- Liste de dossiers -->
          <ion-list
            *ngIf="folder.folders.length > 0"
            class="ion-margin-start ion-no-padding grey-background"
          >
            <div *ngFor="let folderNested1 of folder.folders">
              <ion-card>
                <ion-grid>
                  <ion-row>
                    <ion-col size="1">
                      <div class="height-line-folder" [ngStyle]="{'background-color': folderNested1.color}"></div>
                    </ion-col>
                    <ion-col size="2">
                      <ion-icon
                        class="ion-margin-horizontal bigger-icon"
                        [name]="folderNested1.icon"
                      ></ion-icon>
                    </ion-col>
                    <ion-col size="7">
                      {{ truncateString(folderNested1.name, 14) }}
                    </ion-col>
                    <ion-col size="1">
                      <ng-template
                        [ngIf]="folderNested1.isDeployed"
                        [ngIfElse]="displayedNested1"
                      >
                        <ion-icon
                          (click)="deployFolder(folderNested1)"
                          name="caret-down-outline"
                        ></ion-icon>
                      </ng-template>
                      <ng-template #displayedNested1>
                        <ion-icon
                          (click)="deployFolder(folderNested1)"
                          name="caret-forward-outline"
                        ></ion-icon>
                      </ng-template>
                    </ion-col>
                    <ion-col size="1">
                      <ng-template
                        [ngIf]="deleteMode && !folderNested1.onDelete"
                        [ngIfElse]="deleteMode && onDeleteFolderTrue2">
                        <ion-icon (click)="addFolderToDeleteList(folderNested1)" name="square-outline"></ion-icon>
                      </ng-template>
                      <ng-template #onDeleteFolderTrue2>
                        <ion-icon (click)="removeFolderFromDeleteList(folderNested1)" name="checkbox-outline"></ion-icon>    
                      </ng-template>
                    </ion-col>
                  </ion-row>
                </ion-grid>
              </ion-card>

              <div *ngIf="folderNested1.isDeployed">
                <!-- Liste de notes nested 1 -->
                <ion-list
                  *ngIf="folderNested1.notes.length > 0"
                  class="ion-margin-start ion-no-margin ion-no-padding grey-background"
                >
                  <ion-card
                    class="ion-padding-start card-bg"
                    *ngFor="let noteNested1 of folderNested1.notes"
                  >
                    <ion-grid>
                      <ion-row>
                        <ion-col size="1">
                          <div class="height-line-note" [ngStyle]="{'background-color': folderNested1.color}"></div>
                        </ion-col>
                        <ion-col size="9" 
                          [routerLink]="[
                          '/show',
                          noteNested1.id,
                          currentFolder.name,
                          folder.name,
                          folderNested1.name
                        ]">
                          <ion-label>{{ truncateString(noteNested1.title, 20) }}</ion-label>
                        </ion-col>
                        <ion-col class="ion-no-margin" size="1" >
                          <ion-badge *ngIf="noteNested1.listItems.length > 0 && !deleteMode"
                          class="ion-no-margin"
                          [color]="getNbItemsDone(noteNested1) == noteNested1.listItems.length ? 'success' :
                          getNbItemsDone(noteNested1) == 0 ? 'danger' : 'warning'">
                            {{getNbItemsDone(noteNested1)}}/{{noteNested1.listItems.length}}
                          </ion-badge>
                        </ion-col>
                        <ion-col size="1" *ngIf="deleteMode">
                          <ng-template
                            [ngIf]="deleteMode && !noteNested1.onDelete"
                            [ngIfElse]="deleteMode && onDeleteNoteTrue1">
                            <ion-icon (click)="addNoteToDeleteList(noteNested1)" name="square-outline"></ion-icon>
                          </ng-template>
                          <ng-template #onDeleteNoteTrue1>
                            <ion-icon (click)="removeNoteFromDeleteList(noteNested1)" name="checkbox-outline"></ion-icon>    
                          </ng-template>
                        </ion-col>
                      </ion-row>
                    </ion-grid>
                  </ion-card>
                </ion-list>
              </div>
            </div>
          </ion-list>
          <!-- Liste de notes root -->
          <ion-list
            *ngIf="folder.notes.length > 0"
            class="ion-margin-start ion-no-margin ion-no-padding grey-background"
          >
            <ion-card
              class="ion-padding-start card-bg"
              *ngFor="let note of folder.notes"
            >
              <ion-grid>
                <ion-row class="note-display">
                  <ion-col size="1">
                    <div class="height-line-note" [ngStyle]="{'background-color': folder.color}"></div>
                  </ion-col>
                  <ion-col 
                  [routerLink]="['/show', note.id, currentFolder.name, folder.name]"
                  size="9">
                    <ion-label class="ion-no-margin ion-no-padding ion-margin-end">{{ truncateString(note.title, 20) }}</ion-label>
                  </ion-col>
                  <ion-col size="1">
                    <ion-badge *ngIf="note.listItems.length > 0 && !deleteMode"
                    [color]="getNbItemsDone(note) == note.listItems.length ? 'success' :
                    getNbItemsDone(note) == 0 ? 'danger' : 'warning'">
                      {{getNbItemsDone(note)}}/{{note.listItems.length}}
                    </ion-badge>
                  </ion-col>
                  <ion-col size="1" *ngIf="deleteMode">
                    <ng-template
                      [ngIf]="deleteMode && !note.onDelete"
                      [ngIfElse]="deleteMode && onDeleteNoteTrue2">
                      <ion-icon (click)="addNoteToDeleteList(note)" name="square-outline"></ion-icon>
                    </ng-template>
                    <ng-template #onDeleteNoteTrue2>
                      <ion-icon (click)="removeNoteFromDeleteList(note)" name="checkbox-outline"></ion-icon>    
                    </ng-template>
                  </ion-col>
                </ion-row>
              </ion-grid>
            </ion-card>
          </ion-list>
        </div>
      </div>
    </ion-list>
    <ion-list *ngIf="currentFolder.notes && currentFolder.notes.length > 0" class="grey-background">
      <ion-card
      class="ion-padding-start card-bg"
      
      *ngFor="let note of currentFolder.notes"
    >
      <ion-grid>
        <ion-row>
          <ion-col size="1">
            <div class="height-line-note" [ngStyle]="{'background-color': currentFolder.color}"></div>
          </ion-col>
          <ion-col size="9"
            [routerLink]="['/show', note.id, currentFolder.name]"
          >
            <ion-label class="paddingbot">{{ truncateString(note.title, 20) }}</ion-label>
          </ion-col>
          <ion-col size="1" >
            <ion-badge *ngIf="note.listItems.length > 0 && !deleteMode"
            [color]="getNbItemsDone(note) == note.listItems.length ? 'success' :
            getNbItemsDone(note) == 0 ? 'danger' : 'warning'">
              {{getNbItemsDone(note)}}/{{note.listItems.length}}
            </ion-badge>
          </ion-col>
          <ion-col size="1" *ngIf="deleteMode">
            <ng-template
              [ngIf]="deleteMode && !note.onDelete"
              [ngIfElse]="deleteMode && onDeleteNoteTrue3">
              <ion-icon (click)="addNoteToDeleteList(note)" name="square-outline"></ion-icon>
            </ng-template>
            <ng-template #onDeleteNoteTrue3>
              <ion-icon (click)="removeNoteFromDeleteList(note)" name="checkbox-outline"></ion-icon>    
            </ng-template>
          </ion-col>
        </ion-row>
      </ion-grid>
    </ion-card>

    </ion-list>

  </ng-template>
  <ng-template #noFolderToDisplay>
    <div class="ion-margin">
      Select a folder first
    </div>
  </ng-template>

  <ion-fab *ngIf="currentFolder" horizontal="end" vertical="bottom" slot="fixed">
    <ion-fab-button color="light">
      <ion-icon name="add-outline"></ion-icon>
    </ion-fab-button>
    <ion-fab-list side="top">
      <ion-fab-button
        [routerLink]="[
          '/note', currentFolder.id]">
        <ion-icon name="document-outline"></ion-icon>
      </ion-fab-button>
    </ion-fab-list>
    <ion-fab-list side="start">
      <ion-fab-button
        [routerLink]="[
          '/folder', currentFolder.id]">
        <ion-icon name="folder-outline"></ion-icon> 
      </ion-fab-button>
    </ion-fab-list>
  </ion-fab>

</ion-content>
